#include <libwccl/ops/functions/bool/predicates/isoutside.h>
#include <libwccl/ops/formatters.h>

namespace Wccl {

IsOutside::BaseRetValPtr IsOutside::apply_internal(const FunExecContext& context) const
{
	const boost::shared_ptr<const Position>& pos = pos_expr_->apply(context);
	return Predicate::evaluate(pos->is_outside(context.sentence_context()), context);
}

std::string IsOutside::to_string(const Corpus2::Tagset& tagset) const
{
	return UnaryFunctionFormatter::to_string(tagset, *this, *pos_expr_);
}

std::ostream& IsOutside::write_to(std::ostream& os) const
{
	return os << raw_name() << "(" << *pos_expr_ << ")";
}

} /* end ns Wccl */
